=== debian/changelog ===
libdeflate (1.14-1) unstable; urgency=medium

  * Team upload.

  [ Lance Lin ]
  * Update version to 1.14
  * d/watch: fix regex

 -- Lance Lin <lqi254@protonmail.com>  Mon, 03 Oct 2022 18:55:19 +0700
