=== debian/control ===
Source: libdeflate
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs,
               zlib1g-dev,
               python3 <!nocheck>,
               xxd <!nocheck>,
               debhelper
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
Homepage: https://github.com/ebiggers/libdeflate
Rules-Requires-Root: no

Package: libdeflate0
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: fast, whole-buffer DEFLATE-based compression and decompression
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".

Package: libdeflate-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdeflate0 (= ${binary:Version}),
         ${misc:Depends}
Description: headers for whole-buffer compression and decompression library
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".
 .
 This package provides the development headers.

Package: libdeflate-tools
Architecture: any
Section: libdevel
Depends: libdeflate0 (= ${binary:Version}),
         ${misc:Depends}, ${shlibs:Depends}
Description: tools for whole-buffer compression and decompression library
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".
 .
 This package provides the sample tools.
