=== debian/changelog ===
libdeflate (1.15-1) experimental; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Build-Depends: libdebhelper-perl, cmake
  * Adjust d-shlibs call

  [ Michael R. Crusoe ]
  * d/rules: fix building the tests
  * d/rules: update location of benchmark program

 -- Andreas Tille <tille@debian.org>  Wed, 04 Jan 2023 11:12:50 +0100
