=== debian/changelog ===
libdeflate (1.19-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:02:27 +0200

libdeflate (1.19-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * d/rules: Reduce compiler optimization on alpha (Closes: #1028624)
  * d/libdeflate0.symbols: Add new symbols (libdeflate_alloc_compressor_ex,
    libdeflate_alloc_decompressor_ex)

 -- Lance Lin <lq27267@gmail.com>  Wed, 31 Jan 2024 22:26:50 +0700

libdeflate (1.18-1) unstable; urgency=medium

  [ Lance Lin ]
  * New upstream version
  * d/patches: Removed patch, fixed upstream
  * d/copyright: Update year to 2023

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 10 Aug 2023 10:21:56 +0200
