=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: libdeflate
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Section: science
 Priority: optional
@@ -8,8 +9,9 @@
                zlib1g-dev,
                python3 <!nocheck>,
                xxd <!nocheck>,
-               debhelper
-Standards-Version: 4.6.1
+               libdebhelper-perl,
+               cmake
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
 Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
 Homepage: https://github.com/ebiggers/libdeflate
