## libdeflate 1.20

=== debian/changelog ===
libdeflate (1.20-1) unstable; urgency=medium

  * New upstream version
  * d/rules: stop doing a profile-guide build, especially since CPU
    dispatch is being used.
  * d/copyright: update my email address. Update years for upstream and
    myself.
  * d/{control,rules}: no longer need direct dependency on debhelper-perl.
                       zlib1g-dev is only needed for the tests.
  * use help2man to create manual pages.
  * d/control: expand description of the libdeflate-tools package.
  * d/rules: run even more tests.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 23 Mar 2024 14:26:36 +0100
