=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: libdeflate
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                d-shlibs,
-               zlib1g-dev,
+               cmake,
+               zlib1g-dev <!nocheck>,
                python3 <!nocheck>,
                xxd <!nocheck>,
-               libdebhelper-perl,
-               cmake
+               help2man <!nodoc>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
 Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
@@ -69,4 +68,9 @@
  processors. In addition, libdeflate provides optional high compression modes
  that provide a better compression ratio than the zlib's "level 9".
  .
- This package provides the sample tools.
+ This package provides the sample tool: libdeflate-gzip (and libdeflate-gunzip).
+ This program which can be a drop-in replacement for standard "gzip" under
+ some circumstances.  Note that "libdeflate-gzip" has some  limitations; it is
+ provided for convenience and is **not** meant to be the main use case of
+ libdeflate.  It needs a lot of memory to process large files, and it omits
+ support for some infrequently-used options of GNU gzip.
