## libdeflate 1.21

=== debian/changelog ===
libdeflate (1.21-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * d/rules: skip making manpages if we are cross-building.

  [ Nick Black ]
  * New upstream
  * Upload from team deflate

  [ Andrea Pappacoda ]
  * Correct sections, appropriate .install files, DEP-14

 -- Nick Black <dankamongmen@gmail.com>  Tue, 13 Aug 2024 10:48:52 -0400
