## libdeflate 1.22

=== debian/changelog ===
libdeflate (1.22-1) unstable; urgency=medium

  * New upstream 1.22.

 -- nick black <dankamongmen@gmail.com>  Mon, 07 Oct 2024 02:45:06 -0400
